# main.py
# Pokitto 1q48 Ver.0.1
# by chame (https://twitter.com/chame)

import upygame as upg
import umachine as pok
import urandom as random
#import gc

class GameObject():
    def __init__(self, surfaces, x, y, w, h, vx, vy):
        self.surfaces = surfaces
        self.x = x
        self.y = y
        self.w = w
        self.h = h
        self.vx = vx
        self.vy = vy
        self.status = 1
        self.surfno = 0
        
def randint(a, b, bit):
    while True:
        r = random.getrandbits(bit)
        if r <= b - a:
            break;
    return a + r

def dist2(x1, y1, x2, y2):
    return (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)
    
sin = (
    0,
    195,
    383,
    556,
    707,
    831,
    924,
    981,
    1000,
    981,
    924,
    831,
    707,
    556,
    383,
    195,
    0,
    -195,
    -383,
    -556,
    -707,
    -831,
    -924,
    -981,
    -1000,
    -981,
    -924,
    -831,
    -707,
    -556,
    -383,
    -195
)
cos = (
    1000,
    981,
    924,
    831,
    707,
    556,
    383,
    195,
    0,
    -195,
    -383,
    -556,
    -707,
    -831,
    -924,
    -981,
    -1000,
    -981,
    -924,
    -831,
    -707,
    -556,
    -383,
    -195,
    0,
    195,
    383,
    556,
    707,
    831,
    924,
    981,
)
tan = (
98,
303,
535,
821,
1219,
1871,
3297,
10153,
)
def atan2(y, x):
    if x == 0 and y >= 0:
        return  8
    elif x == 0 and y <  0:
        return 24
    t = y * 1000 // x
    r = 0
    if x > 0 and y >= 0:
        for i in range(0, 8):
            r = i
            if t < tan[i]:
                break
    elif x <  0 and y > 0:
        for i in range(7, -1, -1):
            r = 15 - i
            if t < -tan[i]:
                break
    elif x <  0 and y <= 0:
        for i in range(0, 8):
            r = i + 16
            if t <= tan[i]:
                break
    else: #if x >  0 and y <  0:
        for i in range(7, -1, -1):
            r = 31 - i
            if t <= -tan[i]:
                break    
    return r
#------------------------------------------------------------
# Init
#------------------------------------------------------------
tm = 0
tm_dead = 0
x = 59 * 1000
y = 44 * 1000
vx = 0
vy = 0
sc = 0
hi = 0
alive = True
powcount = 0

list_players = []
list_shots = []
list_bullets = []
list_explosions = []
list_enemies = []
list_clouds = []
list_pows = []

upg.display.init(True)
upg.display.set_palette_16bit([
    0, 6474, 31018, 1066, 43654, 23209, 50712, 65437,
    63497, 64768, 65380, 1830, 11647, 33715, 64437, 65141
])
screen = upg.display.set_mode()
screenRect = screen.get_rect()
g_sound = upg.mixer.Sound()

mode = "title"
#------------------------------------------------------------
# Bitmaps
#------------------------------------------------------------
playerPixels00 = b'\
\x77\x70\x07\x77\
\x01\x01\x10\x10\
\x1d\x1f\xf1\xd1\
\x1d\x11\x11\xd1\
\x01\x11\x11\x10\
\x00\x10\x01\x00\
\x01\xd1\x1d\x10\
\x00\xd0\x0d\x00\
'
playerPixels01 = b'\
\x07\x00\x00\x70\
\x01\x01\x10\x10\
\x1d\x1f\xf1\xd1\
\x1d\x11\x11\xd1\
\x01\x11\x11\x10\
\x00\x10\x01\x00\
\x01\xd1\x1d\x10\
\x00\xd0\x0d\x00\
'
bulletPixels = b'\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
\x00\x09\x90\x00\
\x00\x97\xa4\x00\
\x00\x9a\xa4\x00\
\x00\x04\x40\x00\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
'
shotPixels = b'\
\x07\xf0\x07\xf0\
\x07\xf0\x07\xf0\
\x0a\xa0\x0a\xa0\
\x09\x90\x09\x90\
\x08\x80\x08\x80\
\x08\x80\x08\x80\
\x02\x20\x02\x20\
\x02\x20\x02\x20\
'
explosionPixels00 = b'\
\x00\x00\x00\x88\
\x00\x02\x08\x80\
\x00\x08\x98\x00\
\x08\x8a\xa2\x00\
\x00\x9a\x88\x80\
\x08\xa8\x00\x00\
\x28\x80\x00\x00\
\x88\x00\x00\x00\
'
explosionPixels01 = b'\
\x00\x00\x00\x00\
\x00\x00\x08\x00\
\x00\x28\x88\x00\
\x00\x88\xa8\x00\
\x02\x8a\xa8\x80\
\x00\x88\x98\x00\
\x00\x82\x00\x00\
\x00\x00\x00\x00\
'
explosionPixels02 = b'\
\x00\x82\x88\x00\
\x08\x88\x88\x22\
\x88\x8a\x88\x80\
\x28\x9a\xa8\x80\
\x08\x99\xa8\x80\
\x08\x88\x88\x80\
\x00\x88\x28\x20\
\x02\x00\x00\x08\
'
explosionPixels03 = b'\
\x00\x88\x88\x00\
\x08\x8a\xa8\x28\
\x88\x9a\xa9\x80\
\x28\xaa\xaa\x80\
\x08\x9a\xaa\x80\
\x08\x89\x99\x82\
\x00\x88\x88\x80\
\x08\x00\x00\x08\
'
explosionPixels04 = b'\
\x00\x50\x50\x00\
\x00\x00\x02\x00\
\x02\x0d\x00\x05\
\x00\x05\x5d\x00\
\x50\xd5\x50\x20\
\x00\x0d\xd0\x00\
\x02\x00\x05\x05\
\x00\x05\x00\x00\
'
enemy01Pixels00 = b'\
\x00\xbb\xab\x00\
\x00\x0b\xa0\x00\
\x00\x0b\xb0\x00\
\x00\xbb\xbb\x00\
\xbb\xbe\xeb\xbb\
\xbb\xbe\xeb\xbb\
\x00\x0b\xb0\x00\
\x00\x77\x77\x00\
'
enemy01Pixels01 = b'\
\x00\x00\x00\x00\
\x00\xbb\xab\x00\
\x00\x0b\xa0\x00\
\xbb\xbe\xeb\xbb\
\xbb\xbe\xeb\xbb\
\x00\x0b\xb0\x00\
\x00\x77\x77\x00\
\x00\x00\x00\x00\
'
enemy01Pixels02 = b'\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
\x00\xbb\xab\x00\
\x00\x0b\xa0\x00\
\xbb\xbe\xeb\xbb\
\x00\x77\x77\x00\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
'
enemy01Pixels03 = b'\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
\xbb\xbb\xbb\xbb\
\xbb\xbb\xbb\xbb\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
'
enemy01Pixels04 = b'\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
\x00\x77\x77\x00\
\xbb\xbb\xbb\xbb\
\x00\x0b\xb0\x00\
\x00\xbb\xbb\x00\
\x00\x00\x00\x00\
\x00\x00\x00\x00\
'
enemy01Pixels05 = b'\
\x00\x00\x00\x00\
\x00\x77\x77\x00\
\x00\x0b\xb0\x00\
\xbb\xbb\xbb\xbb\
\xbb\xbb\xbb\xbb\
\x00\x0b\xb0\x00\
\x00\xbb\xbb\x00\
\x00\x00\x00\x00\
'
enemy01Pixels06 = b'\
\x00\x77\x77\x00\
\x00\x0b\xb0\x00\
\xbb\xbb\xbb\xbb\
\xbb\xbb\xbb\xbb\
\x00\xbb\xbb\x00\
\x00\x0b\xb0\x00\
\x00\x0b\xb0\x00\
\x00\xbb\xbb\x00\
'
enemy02Pixels00 = b'\
\x00\x00\x22\x00\
\x00\x02\x82\x00\
\x22\x02\x82\x07\
\x28\x28\xee\x27\
\x28\x28\xee\x27\
\x22\x02\x82\x07\
\x00\x02\x82\x00\
\x00\x00\x22\x00\
'
enemy02Pixels01 = b'\
\x00\x22\x00\x00\
\x02\x82\x02\x20\
\x28\x82\x28\x82\
\x22\x28\x88\x20\
\x00\x28\xee\x00\
\x02\x88\xe2\x07\
\x02\x82\x00\x70\
\x00\x20\x07\x00\
'
enemy02Pixels02 = b'\
\x00\x22\x22\x00\
\x00\x28\x82\x00\
\x00\x02\x20\x00\
\x02\x28\x82\x20\
\x28\x8e\xe8\x82\
\x22\x2e\xe2\x22\
\x00\x02\x20\x00\
\x00\x77\x77\x00\
'
enemy02Pixels03 = b'\
\x00\x00\x22\x00\
\x02\x20\x28\x20\
\x28\x82\x28\x82\
\x02\x88\x82\x22\
\x00\xee\x82\x00\
\x70\x2e\x88\x20\
\x07\x00\x28\x20\
\x00\x70\x02\x00\
'
enemy02Pixels04 = b'\
\x00\x22\x00\x00\
\x00\x28\x20\x00\
\x70\x28\x20\x22\
\x72\xee\x82\x82\
\x72\xee\x82\x82\
\x70\x28\x20\x22\
\x00\x28\x20\x00\
\x00\x22\x00\x00\
'
enemy02Pixels05 = b'\
\x00\x70\x02\x00\
\x07\x00\x28\x20\
\x70\x2e\x88\x20\
\x00\xee\x82\x00\
\x02\x88\x82\x22\
\x28\x82\x28\x82\
\x02\x20\x28\x20\
\x00\x00\x22\x00\
'
enemy02Pixels06 = b'\
\x00\x77\x77\x00\
\x00\x02\x20\x00\
\x22\x2e\xe2\x22\
\x28\x8e\xe8\x82\
\x02\x28\x82\x20\
\x00\x02\x20\x00\
\x00\x28\x82\x00\
\x00\x22\x22\x00\
'
enemy02Pixels07 = b'\
\x00\x20\x07\x00\
\x02\x82\x00\x70\
\x02\x88\xe2\x07\
\x00\x28\xee\x00\
\x22\x28\x88\x20\
\x28\x82\x28\x82\
\x02\x82\x02\x20\
\x00\x22\x00\x00\
'
enemy03Pixels00 = b'\
\x00\x00\x03\x00\
\x00\x00\x33\x00\
\x30\x03\x33\x07\
\xbb\x33\xee\x37\
\x33\x33\xee\x37\
\x30\x03\x33\x07\
\x00\x00\x33\x00\
\x00\x00\x33\x00\
'
enemy03Pixels01 = b'\
\x00\x33\x00\x00\
\x0b\x30\x00\x30\
\x33\xb3\x03\x33\
\x30\x33\x33\x30\
\x00\x03\xee\x00\
\x00\x33\xe3\x07\
\x03\x33\x00\x70\
\x00\x30\x07\x00\
'
enemy03Pixels02 = b'\
\x00\x33\xb3\x00\
\x00\x03\xb0\x00\
\x00\x03\x30\x00\
\x00\x33\x33\x00\
\x33\x3e\xe3\x33\
\x33\x3e\xe3\x33\
\x00\x03\x30\x00\
\x00\x77\x77\x00\
'
enemy03Pixels03 = b'\
\x00\x00\x33\x00\
\x03\x00\x03\xb0\
\x33\x30\x3b\x33\
\x03\x33\x33\x03\
\x00\xee\x30\x00\
\x70\x3e\x33\x00\
\x07\x00\x33\x30\
\x00\x70\x03\x00\
'
enemy03Pixels04 = b'\
\x00\x33\x00\x00\
\x00\x33\x00\x00\
\x70\x33\x30\x03\
\x73\xee\x33\x33\
\x73\xee\x33\xbb\
\x70\x33\x30\x03\
\x00\x33\x00\x00\
\x00\x33\x00\x00\
'
enemy03Pixels05 = b'\
\x00\x70\x03\x00\
\x07\x00\x33\x30\
\x70\x3e\x33\x00\
\x00\xee\x30\x00\
\x03\x33\x33\x03\
\x33\x30\x3b\x33\
\x03\x00\x03\xb0\
\x00\x00\x33\x00\
'
enemy03Pixels06 = b'\
\x00\x77\x77\x00\
\x00\x03\x30\x00\
\x33\x3e\xe3\x33\
\x33\x3e\xe3\x33\
\x00\x33\x33\x00\
\x00\x03\x30\x00\
\x00\x0b\x30\x00\
\x00\x3b\x33\x00\
'
enemy03Pixels07 = b'\
\x00\x30\x07\x00\
\x03\x33\x00\x70\
\x00\x33\xe3\x07\
\x00\x03\xee\x00\
\x30\x33\x33\x30\
\x33\xb3\x03\x33\
\x0b\x30\x00\x30\
\x00\x33\x00\x00\
'
cloudPixels = b'\
\x00\x00\x00\x00\x00\x07\x07\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x70\x70\x70\x70\x00\x00\x00\
\x00\x00\x00\x00\x07\x07\x07\x07\x07\x00\x00\x00\
\x00\x00\x00\x00\x70\x70\x70\x70\x70\x70\x00\x00\
\x00\x00\x00\x07\x07\x07\x07\x07\x07\x07\x00\x00\
\x00\x00\x00\x70\x70\x70\x70\x70\x70\x70\x00\x00\
\x00\x00\x07\x07\x07\x07\x07\x07\x07\x07\x00\x00\
\x00\x00\x00\x70\x70\x70\x70\x70\x70\x70\x70\x00\
\x00\x00\x07\x07\x07\x07\x07\x07\x07\x07\x07\x00\
\x00\x00\x70\x70\x70\x70\x70\x70\x70\x70\x70\x00\
\x00\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x00\
\x00\x70\x70\x70\x70\x70\x70\x70\x70\x70\x70\x00\
\x00\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x00\
\x00\x70\x70\x70\x70\x70\x70\x70\x70\x70\x70\x70\
\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x00\
\x00\x70\x70\x70\x70\x70\x70\x70\x70\x70\x70\x70\
\x00\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x00\
\x00\x70\x70\x70\x70\x70\x70\x70\x70\x70\x70\x70\
\x00\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x00\
\x00\x00\x70\x70\x70\x70\x70\x70\x70\x70\x70\x00\
\x00\x00\x07\x07\x07\x07\x07\x07\x07\x07\x00\x00\
\x00\x00\x00\x00\x70\x70\x70\x70\x70\x70\x00\x00\
\x00\x00\x00\x00\x07\x07\x07\x07\x07\x00\x00\x00\
\x00\x00\x00\x00\x00\x70\x70\x70\x00\x00\x00\x00\
'

logoPixels = b'\
\x00\x00\x00\x00\x00\x07\x77\x77\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x77\x77\x77\x77\x77\x00\x00\x00\x00\x00\x00\x00\x00\x07\x77\x77\x77\x77\x70\x00\x00\x00\
\x00\x00\x00\x00\x00\x77\x77\x77\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x77\x77\x77\x77\x77\x00\x00\x00\x00\x00\x00\x00\x00\x77\x77\x77\x77\x77\x77\x00\x00\x00\
\x00\x00\x00\x00\x07\x70\x00\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x77\x00\x00\x00\x00\x77\x00\x00\x00\x00\x00\x00\x00\x07\x70\x00\x00\x00\x00\x07\x70\x00\x00\
\x00\x00\x00\x00\x77\x00\x00\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x77\x00\x00\x00\x00\x77\x00\x00\x00\x00\x00\x00\x00\x77\x00\x00\x00\x00\x00\x00\x77\x00\x00\
\x00\x00\x00\x07\x7b\xbb\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x37\x7b\xbb\xbb\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x07\x7b\xbb\xbb\xbb\xb0\x00\x00\x07\x70\x00\
\x00\x00\x00\x77\xbb\xbb\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x37\x7b\xbb\xbb\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x77\xbb\xbb\xbb\xbb\xbb\x00\x00\x00\x77\x00\
\x00\x00\x07\x7b\xbb\xb7\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x77\xbb\xbb\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x03\x77\xbb\xbb\x77\x77\x77\x77\x00\x00\x77\x00\
\x00\x00\x77\xbb\xbb\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x77\xbb\xbb\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x33\x77\xbb\xbb\x77\x77\x77\x77\x00\x00\x77\x00\
\x00\x03\x77\xbb\xb7\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x37\x7b\xbb\xb7\x77\xbb\x00\x77\x00\x00\x00\x00\x03\x33\x77\xbb\xbb\x77\xbb\xbb\x77\xb0\x00\x77\x00\
\x00\x33\x77\xbb\x77\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x37\x7b\xbb\xb7\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x77\xbb\xbb\x77\xbb\xbb\x77\xbb\x00\x77\x00\
\x03\x33\x77\xb7\x73\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x77\xbb\xbb\x77\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x77\xbb\xbb\x77\xbb\xbb\x77\xbb\x00\x77\x00\
\x33\x33\x77\x77\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x77\xbb\xbb\x77\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x77\xbb\xbb\x77\xbb\xbb\x77\xbb\x00\x77\x00\
\x33\x33\x77\x73\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x37\x7b\xbb\xb7\x7b\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x77\x77\x77\xbb\x00\x77\x00\
\x33\x33\x77\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x37\x7b\xbb\xb7\x7b\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x77\x77\x77\xbb\x00\x77\x00\
\x33\x33\x70\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x07\x77\x77\x77\x77\x70\x77\x77\x77\x77\x00\x00\x33\x77\xbb\xbb\x77\xbb\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x00\xbb\xbb\xbb\xbb\x00\x77\x00\
\x33\x33\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x00\x00\x33\x77\xbb\xbb\x77\xbb\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x37\x7b\x00\x00\xbb\xbb\xbb\xbb\x07\x70\x00\
\x33\x30\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x07\x70\x00\x00\x00\x00\x07\x77\x00\x00\x77\x00\x03\x37\x7b\xbb\xb7\x7b\xbb\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\x77\x00\x00\
\x33\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x77\x00\x00\x00\x00\x00\x00\x77\x00\x00\x77\x00\x03\x37\x7b\xbb\xb7\x7b\xbb\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x33\x33\x77\x7b\xbb\xbb\xbb\xbb\xb7\x77\x00\x00\
\x30\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x07\x7b\xbb\xbb\xbb\xb0\xbb\xbb\xb7\xbb\x00\x77\x00\x33\x77\xbb\xbb\x77\x77\x77\x77\xbb\x00\x77\x77\x77\x77\x00\x33\x33\x37\x7b\xbb\xbb\xbb\xbb\xbb\xbb\x07\x70\x00\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x00\x77\x00\x33\x77\xbb\xbb\x77\x77\x77\x77\xbb\x00\x77\x77\x77\x77\x00\x03\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\xb0\x00\x77\x00\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x03\x77\xbb\xbb\x77\x77\x77\x77\xbb\xbb\xbb\x00\x77\x03\x33\x77\xbb\xb0\x00\xbb\xbb\xbb\xbb\x00\x00\x00\x00\x77\x00\x00\x37\x7b\xbb\xbb\xbb\xbb\xbb\xbb\x00\x00\x07\x70\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x33\x77\xbb\xbb\x77\x77\x77\x77\xbb\xbb\xbb\x00\x77\x03\x33\x77\xbb\xb0\x00\xbb\xbb\xbb\xbb\x00\x00\x00\x00\x77\x00\x00\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x00\x00\x00\x77\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x03\x33\x77\xbb\xbb\x77\x33\x33\x77\xbb\xbb\xbb\x00\x77\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x00\x77\x00\x03\x77\xbb\xbb\x77\x77\x77\x77\x77\x77\x00\x00\x77\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\xbb\xbb\x77\x33\x33\x77\xbb\xbb\xbb\x00\x77\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x00\x77\x00\x33\x77\xbb\xbb\x77\x77\x77\x77\x77\x77\x00\x00\x77\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\xbb\xbb\x77\x33\x33\x77\xbb\xbb\xbb\x00\x77\x33\x33\x77\x77\x77\x77\x77\x77\x77\xbb\xbb\x77\x77\x77\x77\x03\x33\x77\xbb\xbb\x77\xbb\xbb\xbb\xbb\x77\xb0\x00\x77\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\xbb\xbb\x77\x33\x33\x77\xbb\xbb\xbb\x00\x77\x33\x33\x77\x77\x77\x77\x77\x77\x77\xbb\xbb\x77\x77\x77\x77\x33\x33\x77\xbb\xbb\x77\xbb\xbb\xbb\xbb\x77\xbb\x00\x77\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x77\x77\x77\xbb\xbb\xbb\x00\x77\x33\x33\x33\x33\x33\x33\x33\x33\x77\xbb\xbb\x77\x33\x00\x00\x33\x33\x77\xbb\xbb\x77\xbb\xbb\xbb\xbb\x77\xbb\x00\x77\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x77\x77\x77\xbb\xbb\xbb\x00\x77\x33\x33\x33\x33\x33\x33\x33\x33\x77\xbb\xbb\x77\x33\x00\x00\x33\x33\x77\xbb\xbb\x77\xbb\xbb\xbb\xbb\x77\xbb\x00\x77\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\xbb\x00\x00\xbb\xbb\xbb\xbb\xbb\xbb\x00\x77\x33\x33\x33\x33\x33\x33\x33\x33\x77\xbb\xbb\x77\x33\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\xbb\xbb\x77\xbb\x00\x77\
\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x37\x7b\x00\x00\xbb\xbb\xbb\xbb\xb7\xbb\x00\x77\x33\x33\x33\x33\x33\x33\x33\x33\x77\xbb\xbb\x77\x33\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\xbb\xbb\x77\xbb\x00\x77\
\x00\x00\x77\x77\x77\x77\xbb\x00\x77\x77\x77\x77\x33\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x77\x77\x77\x77\xbb\x00\x77\x77\x77\x77\x33\x33\x77\xbb\x00\x77\x77\x77\x77\x77\x77\xbb\x00\x77\
\x00\x00\x77\x77\x77\x77\xbb\x00\x77\x77\x77\x77\x33\x33\x33\x37\x7b\xbb\xbb\xbb\xbb\xb7\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x77\x77\x77\x77\xbb\x00\x77\x77\x77\x77\x33\x33\x77\xbb\x00\x77\x77\x77\x77\x77\x77\xbb\x00\x77\
\x00\x00\x77\xbb\xbb\xbb\xbb\x00\x00\x00\x00\x77\x33\x33\x33\x33\x77\x77\x77\x77\x77\x77\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x77\xbb\xbb\xbb\xbb\x00\x00\x00\x00\x77\x33\x33\x77\xbb\x00\x00\x00\x00\xbb\xbb\xbb\xbb\x00\x77\
\x00\x00\x77\xbb\xbb\xbb\xbb\x00\x00\x00\x00\x77\x03\x33\x33\x33\x37\x77\x77\x77\x77\x73\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x77\xbb\xbb\xbb\xbb\x00\x00\x00\x00\x77\x33\x33\x37\x7b\x00\x00\x00\x00\xbb\xbb\xbb\xbb\x07\x70\
\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x00\x77\x00\x33\x33\x33\x33\x33\x33\x33\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x00\x77\x33\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x77\x00\
\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x00\x77\x00\x03\x33\x33\x33\x33\x33\x33\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x00\x77\x33\x33\x33\x37\x7b\xbb\xbb\xbb\xbb\xbb\xbb\xb7\x70\x00\
\x33\x33\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x00\x00\x33\x33\x33\x33\x33\x33\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x33\x33\x33\x33\x77\x77\x77\x77\x77\x77\x77\x77\x00\x00\
\x33\x33\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x00\x00\x03\x33\x33\x33\x33\x30\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x03\x33\x33\x33\x37\x77\x77\x77\x77\x77\x77\x70\x00\x00\
\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\
\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x03\x33\x33\x33\x33\x33\x33\x33\x33\x30\x00\x00\x00\
\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x00\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x00\
\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\x00\x00\x00\x00\x03\x33\x33\x33\x33\x33\x33\x30\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\xbb\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\x77\x77\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x77\x77\x77\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x33\x33\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x33\x33\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x33\x33\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x33\x33\x33\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
'
playerSurfaces  = [
    upg.surface.Surface(8, 8, playerPixels00),
    upg.surface.Surface(8, 8, playerPixels01)
]
bulletSurfaces  = [
    upg.surface.Surface(8, 8, bulletPixels)
]
shotSurfaces  = [
    upg.surface.Surface(8, 8, shotPixels)
]
explosionSurfaces = [
    upg.surface.Surface(8, 8, explosionPixels00),
    upg.surface.Surface(8, 8, explosionPixels01),
    upg.surface.Surface(8, 8, explosionPixels02),
    upg.surface.Surface(8, 8, explosionPixels03),
    upg.surface.Surface(8, 8, explosionPixels04)
]
enemy01Surfaces = [
    upg.surface.Surface(8, 8, enemy01Pixels00),
    upg.surface.Surface(8, 8, enemy01Pixels01),
    upg.surface.Surface(8, 8, enemy01Pixels02),
    upg.surface.Surface(8, 8, enemy01Pixels03),
    upg.surface.Surface(8, 8, enemy01Pixels04),
    upg.surface.Surface(8, 8, enemy01Pixels05),
    upg.surface.Surface(8, 8, enemy01Pixels06)
]
enemy02Surfaces = [
    upg.surface.Surface(8, 8, enemy02Pixels00),
    upg.surface.Surface(8, 8, enemy02Pixels01),
    upg.surface.Surface(8, 8, enemy02Pixels02),
    upg.surface.Surface(8, 8, enemy02Pixels03),
    upg.surface.Surface(8, 8, enemy02Pixels04),
    upg.surface.Surface(8, 8, enemy02Pixels05),
    upg.surface.Surface(8, 8, enemy02Pixels06),
    upg.surface.Surface(8, 8, enemy02Pixels07)
]
enemy03Surfaces = [
    upg.surface.Surface(8, 8, enemy03Pixels00),
    upg.surface.Surface(8, 8, enemy03Pixels01),
    upg.surface.Surface(8, 8, enemy03Pixels02),
    upg.surface.Surface(8, 8, enemy03Pixels03),
    upg.surface.Surface(8, 8, enemy03Pixels04),
    upg.surface.Surface(8, 8, enemy03Pixels05),
    upg.surface.Surface(8, 8, enemy03Pixels06),
    upg.surface.Surface(8, 8, enemy03Pixels07)
]
cloudSurfaces = [
    upg.surface.Surface(24, 24, cloudPixels)
]
logoSurface = upg.surface.Surface(110, 54, logoPixels)
#------------------------------------------------------------
# Sound
#------------------------------------------------------------
sound1 = b'\
\x7b\xc7\x84\x35\x2a\xc8\xbd\x59\xab\x3a\x4b\xa8\xc3\x3a\x8b\xa5\x2d\x1c\x85\x52\
\x99\x2b\x72\xb2\x5b\x34\x65\x82\x7b\x46\xb2\x3c\x7a\x83\xa6\x25\x3b\xbb\xc4\xcc\
\xa3\x6b\x5a\xbb\xb3\x9d\x24\x98\x4a\xba\x59\x74\xc4\xaa\x2a\x91\xac\xcb\x34\x34\
\xc9\x9c\xd6\xb3\xa4\x58\x24\xa4\x11\x7c\x22\x2b\x2a\x5b\xaa\x43\x9c\xc4\xba\xa6\
\x54\x37\x24\x36\xa3\x47\x43\x26\xa2\xa4\xab\x44\x6b\x2a\xb3\x33\x69\x2b\x69\xa4\
\x72\x5b\x53\xa2\x34\x45\xca\x38\x94\x52\xa7\xab\x36\xb4\x39\x89\x48\x5c\xba\x43\
\x28\x58\xc9\x23\xb7\xa5\x45\x9c\xa8\x6b\x34\x59\xb4\xab\xc5\x5b\xc4\x7a\xc3\x8c\
\xb4\x44\xca\x34\xcb\x4b\x23\x54\xaa\x94\x88\x98\xbb\xbb\x32\x25\x55\x33\x33\xa4\
\x34\xc4\x95\xb5\x43\xc8\x6a\xac\x54\x94\x53\x3a\x49\xb4\x88\x28\xb9\x45\x82\x3a\
\xb5\x5b\x74\xb3\x73\x27\x8a\xb8\x7b\xb3\x4b\x94\x33\xa2\x89\x99\x9a\xa6\x43\x43\
\xb8\x54\x33\x63\xb8\x4c\xb3\x3c\x85\x8b\xb2\x5a\x23\x56\x93\x37\xa6\x49\xab\xb2\
\xa3\x79\x5c\x63\x39\x69\x2a\x7c\x93\xbc\x44\x56\x7a\x95\x99\x39\x99\xb2\x34\xa4\
\x69\x96\x64\x38\xa9\x87\xab\x34\xb3\xc8\x74\xba\x4b\x58\x35\x39\x59\x7a\x43\x43\
\x34\x4b\x43\xc3\xab\xbb\x53\x65\x46\xc5\x3b\x39\x5b\x54\xa9\x4b\x47\x36\x43\xb4\
\x69\x4a\x39\xba\xa5\xb3\xba\x8b\xb6\xab\xb5\x63\x54\x5a\xb5\x95\x48\x45\x45\x4b\
\xb8\x85\xa4\x4b\x52\x5b\x93\x54\x4b\x56\x64\x3a\xab\x45\xa4\x38\xa4\x37\xa9\x54\
\xaa\xb7\x99\xa6\x35\x36\xab\x3a\x65\xb8\x93\x48\xa3\x36\x83\xb9\x66\xa9\x65\xa9\
\x75\x4a\x83\xa8\x5b\x75\x56\x54\x68\x53\x85\xa3\x87\x9b\x4b\x9b\x35\x63\x96\x3b\
\x44\xa9\x95\x34\x99\xa4\xa6\x95\x96\x54\x5a\x9a\x59\x8a\x84\x78\x59\x6a\x95\x94\
\x48\x96\xb4\x64\x5a\x78\x44\x7a\x9b\x74\xbb\x99\x5b\xa8\xaa\xa8\xaa\x97\x3a\xb8\
\x59\x47\xa4\x95\x48\x84\x44\x69\x7a\xb6\xb5\x98\x6a\x89\x95\xb9\x6a\xa8\x78\xbb\
\xa9\x84\x9a\xa8\x75\x55\x89\x43\x8a\x9a\x94\x95\x95\xa6\x58\xa4\xa9\x54\x5a\xa3\
\x44\x94\xaa\xa9\x56\x85\x59\xab\xb5\x68\x58\x4b\x55\x65\x46\x4b\x94\xa6\x55\x8a\
\xaa\xa6\xa5\x95\xb4\x85\xa9\x59\x45\xb5\x68\x8a\x97\x98\x54\x37\xa5\xa7\x49\x48\
\x54\x49\x46\xa5\x4a\x66\x54\x95\x44\x69\x99\x58\x7b\x49\x5a\x56\x66\x48\x74\x99\
\x79\x64\x96\x6a\x58\x98\x69\x98\x65\x54\x78\x45\x69\x95\xa5\x53\x86\x55\x98\xaa\
\x9a\xa4\xa7\x56\x4a\x75\x56\x55\x75\x55\x96\x6a\x97\x88\x89\x54\x89\x49\x9a\x69\
\x6a\x57\x6a\x86\x94\x78\x9a\x66\x54\x78\xa4\x96\x65\x67\x44\xa6\x64\x49\x84\x96\
\x5a\x9a\xaa\x98\x99\x98\x55\x49\x6a\x5a\x54\x58\x75\x69\xa9\xa5\x64\xa4\x6a\x46\
\x45\x5a\x4a\xa8\x6a\x59\x79\x89\x89\x96\x55\xa6\x85\x65\x5a\xa6\x8a\x55\x57\x94\
\x59\x45\x99\x46\xa7\x44\x86\xaa\x97\x94\x99\x95\x58\x55\x45\x79\x98\x49\x9a\x99\
\x76\x79\x64\x79\x6a\x76\x46\x56\x8a\x69\x55\x79\xaa\x6a\x85\x75\x44\x65\x9a\xa5\
\x4a\x69\x85\x49\x59\x86\x89\x66\x85\x95\x85\x85\x59\x95\x99\x85\x79\x85\x59\x46\
\x56\x55\x65\x69\x69\x99\xaa\xa6\x89\xa6\x89\x59\x78\x69\x58\x99\x57\x65\x54\x69\
\xa6\x55\x67\x58\x97\x54\x97\x96\x97\x89\x95\x65\x55\x68\x56\x76\x54\x95\x84\x58\
\xaa\x86\x55\x88\x56\x75\x95\x95\x99\x75\x79\x97\x98\x87\x98\xa8\x98\x76\x89\x99\
\x69\x66\x55\x68\x84\x99\x89\x56\x65\x99\x68\x75\x98\x95\x58\x85\x65\x97\x78\x55\
\x65\x98\x78\x66\x86\x99\x95\x96\x78\x99\x89\x89\x69\x96\x86\x99\x69\x99\x67\x85\
\x66\x87\x99\x58\x95\x69\x55\x85\x88\x55\x87\x59\x95\x65\x96\x56\x96\x85\x85\x98\
\x65\x86\x58\x99\x69\x58\x96\x59\x95\x98\x87\x57\x69\x86\x87\x57\x68\x85\x87\x97\
\x59\x97\x59\x95\x66\x69\x68\x59\x69\x85\x69\x69\x78\x98\x75\x55\x86\x76\x89\x55\
\x78\x95\x78\x69\x69\x66\x55\x66\x67\x95\x66\x66\x99\x75\x67\x58\x67\x98\x89\x85\
\x66\x55\x69\x75\x89\x96\x88\x77\x65\x65\x66\x65\x88\x88\x66\x68\x68\x76\x58\x78\
\x78\x89\x56\x65\x68\x56\x98\x98\x85\x86\x98\x86\x85\x76\x79\x57\x65\x87\x59\x56\
\x87\x57\x87\x66\x86\x65\x98\x66\x85\x66\x89\x57\x87\x86\x78\x86\x77\x59\x66\x66\
\x86\x68\x66\x89\x86\x66\x76\x87\x69\x88\x76\x66\x88\x67\x68\x66\x68\x86\x87\x88\
\x67\x67\x67\x78\x66\x78\x77\x67\x68\x88\x68\x78\x77\x76\x67\x78\x66\x76\x87\x86\
\x76\x78\x86\x67\x78\x68\x78\x76\x86\x88\x66\x67\x76\x67\x68\x77\x76\x86\x88\x77\
\x86\x67\x78\x87\x88\x77\x68\x77\x76\x66\x67\x78\x88\x77\x77\x77\x88\x77\x76\x66\
\x77\x87\x77\x76\x78\x76\x77\x76\x77\x87\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
'
sound2 = b'\
\x73\x33\x32\x22\x22\x22\x22\x22\x22\x24\x44\x22\x44\x4b\xa9\x9b\xcc\xcc\xcc\x99\
\x9b\x66\x64\x2b\xbb\x53\x33\x3c\xcc\xcb\xb4\x44\x59\xbb\x94\x88\x8b\xbc\xcc\xcc\
\xcc\xcc\xcc\xcb\xb9\x99\x9c\xcc\xaa\xbb\xbc\xcb\xbb\xcb\xbb\x85\xbb\xba\x22\x22\
\x44\x44\x22\x44\x44\x22\x24\x94\x44\x22\x33\x32\x44\x46\xab\xbb\xcc\xcc\xcc\xcc\
\xcc\xcc\xcc\xca\x99\x9a\xcc\xcb\xa8\x88\xc8\x88\x74\xbb\xb4\x43\x33\x9b\xbb\x99\
\x44\x47\xab\xbb\x94\x44\x9a\xbb\xba\x64\x45\x63\x33\x22\xbb\xb9\x44\x4a\xc5\x55\
\x33\x44\x42\x22\x22\x25\x55\x99\x99\x9c\x44\x45\x5c\xcc\x93\x22\x2a\xcc\xca\x72\
\x22\x7c\xcc\x85\x22\x29\x9c\xcc\xa2\x22\x45\xcc\xc3\x22\x22\x93\x33\x33\x55\x52\
\x35\x58\xab\xbb\xcc\x44\x48\xbb\xb9\x22\x22\x44\x66\x68\x99\x9a\xbc\xcc\xcc\xcc\
\xcc\xbb\xbb\xbc\xcc\x73\x33\x35\xaa\xa4\x43\x33\x74\x33\x33\x55\x53\x39\x99\xc4\
\x44\x7a\xcc\xca\xbb\xbb\xcc\xcc\xcc\xbb\xb4\x43\x33\x2a\xaa\x99\x44\x4b\x55\x55\
\x3a\xaa\x44\x33\x3b\x75\x54\x45\x55\x22\x22\x22\x77\x75\x42\x22\x98\x88\x83\x33\
\x33\x32\x22\x23\x33\x22\x22\x23\x32\x22\x22\x22\x22\x22\x22\x38\x88\xbb\xbb\xcc\
\xaa\xaa\xbc\xcb\x92\x22\x45\xcc\xc4\x44\x46\xca\xaa\xaa\xaa\xa4\x44\x44\x4b\xbb\
\xcb\xbb\xbc\xcc\xcc\xcc\xcc\xb9\x44\x58\xcc\xca\xa9\x99\xcc\xcc\xcc\xcc\xcb\xbb\
\xbb\xcb\xbb\xbb\xcc\xcc\xc6\x67\xb8\x88\x22\x44\x42\x45\x56\xa8\x88\xbb\x44\x43\
\xac\xca\x92\x22\x99\x66\x62\x22\x22\x22\x22\x22\x22\x24\x33\x33\x3b\xbb\xaa\xaa\
\xbc\xcc\xcc\xcc\xcc\xcb\xbb\xbc\xbb\xb8\x8a\xaa\x93\x33\x44\xbb\xb5\x55\x57\xcb\
\xbb\xbb\xbb\xbb\x54\x44\x44\x44\x22\x55\x55\x67\x7b\xca\xaa\xaa\x55\x52\xaa\xa8\
\x59\x99\xcc\x99\x9a\xcc\xc4\x43\x33\x97\x44\x33\xaa\xa4\x45\x55\xba\x99\x9a\xaa\
\xa5\x5b\xbb\xb6\x33\x55\xcc\xc6\x65\x59\xca\xaa\xaa\xcc\xca\x94\x44\xbc\xcc\xaa\
\xaa\xac\x86\x68\x84\x44\x23\x44\x43\x44\x47\xaa\xaa\xbb\x55\x55\x55\x53\x39\x99\
\xa6\x22\x48\xaa\xa2\x22\x22\x33\x33\x33\x33\x34\x45\x55\x53\x33\x44\xaa\xa6\x54\
\x44\xa9\x99\x54\x55\x54\x43\x33\x34\x44\x33\x22\x23\x89\x95\x43\x33\x99\xbb\xb8\
\x54\x47\x9b\xbb\xaa\x99\x9b\xbb\xba\xab\xbb\xb9\x88\x99\xbb\xba\xa8\x88\xbb\x66\
\x54\x77\x73\x39\x9a\xb3\x33\xaa\x99\x93\x33\x33\x33\x33\x33\x33\x36\x6b\xbb\xb9\
\x99\xbb\x99\x93\xaa\xa6\x43\x33\x44\x77\x73\x33\x33\x33\x33\x33\x33\x33\x33\x33\
\x33\x33\x33\x33\x33\x33\x33\x34\x44\x44\x55\xab\xaa\xab\xbb\xba\xa4\x44\x33\xbb\
\xb9\x93\x33\xba\xaa\x44\x33\x33\x33\x33\x33\x33\x33\x77\x75\x43\x35\xbb\xbb\xbb\
\x55\x57\x9b\xb5\x53\x33\x33\x55\x43\x66\x6a\xa3\x33\x9a\xbb\xb6\x44\x4b\xbb\xbb\
\xa6\x33\x44\x55\x53\x33\x33\x38\x99\xaa\x55\x5b\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\
\xbb\xba\xaa\xaa\xaa\xa3\x33\x33\x34\x44\x33\x44\x49\x43\x34\x4b\xbb\x54\x33\x4a\
\x86\x64\x4a\xaa\x55\x44\x4a\x99\x94\x49\x99\x88\x99\xbb\xbb\xbb\xbb\xbb\xbb\xaa\
\xbb\xbb\xb5\x55\x55\x5a\xaa\xaa\x55\x5a\xbb\xbb\xaa\xaa\xbb\xbb\xba\xab\xbb\xa9\
\x99\xbb\xbb\xba\x44\x44\x48\x88\x33\x33\x34\x69\x95\x53\x33\x88\xaa\x74\x44\x46\
\x6b\xbb\xba\x88\xbb\xbb\xbb\xb5\x55\xaa\x99\x43\x33\x33\x33\x33\x33\x33\x33\x55\
\x56\x53\x33\x95\x55\x33\x44\x43\x34\x48\xab\xbb\xbb\xaa\xab\xa9\x94\x33\x33\x33\
\x99\x98\x43\x39\x9b\xbb\x55\x44\x8a\xbb\xbb\xbb\xbb\xbb\xaa\xab\xbb\xb9\x98\x88\
\xbb\xbb\xbb\x55\x59\x9b\xba\x73\x33\x44\x66\x63\x33\x33\x33\x33\x44\x44\x43\x68\
\x86\x63\x33\x55\x99\x94\x43\x34\x5b\xbb\xbb\xaa\xab\xaa\xa9\x9a\xaa\x54\x33\x33\
\xaa\xa5\x59\x99\xbb\xaa\xab\xbb\xba\xa8\x88\xba\xaa\x88\x99\x95\x6a\xab\xba\x99\
\xbb\x99\x94\x4a\xaa\x69\x99\xbb\xbb\xbb\xba\xa9\x9b\xbb\x99\x44\x49\x99\x95\x46\
\x66\x66\x44\x48\x99\x95\x5b\xbb\xbb\xaa\xbb\x96\x65\x59\x99\x33\x66\x8a\xaa\xab\
\xbb\xbb\xb6\x55\x44\xaa\xa3\x34\x44\xa8\x55\x89\xbb\xb9\x97\x78\xb9\x99\x66\xbb\
\xb9\x85\x59\xa6\x55\x33\xbb\xb9\x83\x39\xb9\x99\x33\xaa\x86\x33\x39\x9a\xaa\x55\
\x44\x59\x64\x44\x44\x44\x33\x33\x33\x33\x33\x39\x99\x95\x33\xaa\xbb\xb9\x93\x33\
\x55\x55\x33\x33\x33\x34\x45\x65\x55\x99\x99\x99\x9a\xaa\xa9\x99\xaa\xbb\xba\xab\
\xbb\xbb\xbb\xbb\xbb\xbb\xa8\x8a\xab\xbb\x88\x33\x34\x9a\xa3\x33\x33\x54\x44\x33\
\x44\x43\x33\x33\x33\x33\x33\x33\x33\x35\x55\x55\x55\xbb\xbb\xbb\xb8\x89\x9a\xbb\
\x55\x33\x35\x54\x43\x38\x88\x55\x55\x5b\xaa\xaa\xa9\x99\x44\x33\x33\x39\x94\x44\
\x44\xbb\xbb\xbb\xaa\xab\xb5\x55\x45\x99\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\
\x36\x66\x73\x33\x99\xaa\xa6\x65\x58\x95\x44\x33\x66\x63\x33\x33\x34\x44\x33\x88\
\x89\x85\x5b\xbb\xbb\xbb\xaa\xaa\xaa\xa5\x59\x99\x99\x55\x69\xbb\xba\xa3\x33\x55\
\xbb\x55\x43\x3a\xab\xbb\xa9\x44\x78\xbb\xb5\x54\x46\x9a\xbb\xaa\x99\x9b\xb8\x85\
\x48\xbb\x88\x44\x4b\xbb\xbb\xb5\x55\x88\xbb\xa8\x89\x9b\xbb\xbb\xbb\x66\x64\x56\
\x63\x34\x44\x44\x44\x79\x86\x66\x6b\xbb\xaa\x33\x69\xab\xb5\x55\x55\xbb\xbb\xbb\
\x55\x55\x5b\xba\x86\x44\xbb\xbb\xba\xaa\xaa\xa5\x44\x44\xbb\xb8\x74\x4a\xba\xaa\
\x55\x99\x95\x58\x8a\xa5\x55\x66\xbb\xb8\x54\x4a\xa8\x88\x44\x55\x44\x48\x89\x94\
\x44\x55\xaa\xa5\x44\x45\x5a\xaa\x54\x44\xaa\x99\x95\x54\x44\x44\xaa\x99\x44\x4a\
\xa9\x99\x44\x44\x44\x99\x99\x95\x5a\xaa\xaa\xaa\xaa\xaa\xaa\xaa\x98\x88\x44\x88\
\x85\x44\x44\x4a\xaa\x77\x44\x99\x96\x64\x49\x99\x55\x44\x45\xaa\xa6\x68\x88\xaa\
\xaa\xaa\xaa\xaa\xaa\xaa\xaa\x77\x44\x66\x64\x45\x56\x96\x66\xaa\x99\x98\x88\x84\
\x44\x44\x44\x44\x44\x48\x86\x64\x44\x88\xaa\x97\x89\x9a\xa8\x88\x99\x99\x54\x45\
\x55\x54\x44\x55\x44\x44\x44\x44\x45\x56\x88\x44\x55\x9a\xa5\x54\x44\x57\x99\x66\
\x44\x44\x49\x96\x44\x44\x77\xaa\xa9\x94\x46\x66\x55\x44\x55\x55\x44\x46\x65\x55\
\x44\x99\x98\x85\x5a\xa9\x99\x88\x88\x65\x89\x99\x96\x66\xaa\xaa\x99\x88\x87\x7a\
\xaa\xaa\x55\x99\xaa\xa9\x95\x55\xa9\x99\x66\xaa\xa9\x97\x79\xaa\x99\x55\x55\x44\
\x45\x54\x44\x44\x44\x44\x44\x45\x55\x55\x66\x99\x44\x55\x56\x64\x44\x44\x44\x88\
\x88\x44\x46\x6a\xaa\x55\x55\x99\x86\x68\x89\x99\x66\x55\x78\xaa\xa9\x94\x44\x66\
\x66\x44\x44\x44\x45\x55\x55\x66\xaa\x99\x9a\xaa\xaa\xa5\x55\x88\xaa\xa5\x55\x59\
\x97\x66\x88\x66\x55\x59\x98\x85\x55\x99\xa9\x96\x66\x67\x79\x99\x88\x88\x99\x75\
\x55\x55\x55\x44\x66\x65\x44\x48\x86\x65\x44\x55\x55\x55\x59\x95\x56\x67\x88\x55\
\x99\x99\x99\x99\xa9\x66\x66\xaa\x95\x56\x6a\xa9\x88\x99\x99\x98\x89\x9a\xaa\xaa\
\xaa\xaa\xaa\xa9\x98\x89\x99\x66\x55\x55\x89\x98\x85\x55\x99\x66\x55\x99\x98\x85\
\x57\x99\x99\x88\x66\x67\x79\x98\x68\x88\x99\x99\x99\x96\x66\x66\x66\x55\x88\x88\
\x88\x89\x99\x99\x99\x99\x99\x99\x98\x86\x66\x55\x55\x55\x55\x55\x59\x99\x77\x77\
\x99\x88\x88\x88\x88\x55\x88\x77\x76\x69\x99\x99\x99\x66\x66\x99\x95\x55\x55\x86\
\x66\x66\x88\x86\x65\x56\x67\x99\x99\x55\x68\x89\x96\x65\x55\x88\x99\x98\x85\x58\
\x88\x88\x55\x66\x66\x65\x55\x59\x99\x66\x55\x68\x66\x65\x59\x99\x77\x55\x99\x99\
\x99\x95\x56\x67\x77\x55\x66\x66\x68\x88\x99\x99\x99\x88\x87\x79\x98\x87\x55\x66\
\x99\x96\x65\x58\x97\x66\x55\x55\x55\x55\x56\x67\x88\x99\x66\x88\x87\x75\x56\x66\
\x55\x55\x66\x66\x65\x55\x55\x55\x55\x55\x55\x55\x58\x88\x88\x66\x99\x99\x99\x99\
\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\
\x98\x87\x77\x77\x66\x66\x66\x66\x66\x66\x66\x66\x66\x66\x66\x66\x66\x66\x66\x88\
\x88\x88\x88\x88\x88\x66\x66\x66\x66\x66\x67\x77\x66\x66\x66\x88\x76\x66\x66\x66\
\x66\x66\x66\x66\x66\x66\x66\x88\x77\x66\x77\x78\x86\x67\x77\x88\x77\x88\x88\x86\
\x68\x88\x66\x88\x88\x88\x88\x87\x77\x77\x77\x66\x66\x66\x66\x66\x77\x66\x77\x78\
\x87\x77\x77\x77\x77\x66\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
'
sound3 = b'\
\x79\xaa\xbb\xbb\xba\xa9\x85\x43\x33\x33\x44\x58\x9a\xbb\xbb\xba\xa9\x54\x43\x33\
\x34\x46\x9a\xbb\xbb\xba\x96\x44\x33\x33\x45\x8a\xab\xbb\xba\x95\x43\x33\x34\x58\
\xaa\xbb\xba\xa6\x43\x33\x34\x59\xab\xbb\xaa\x74\x33\x33\x48\xaa\xbb\xba\x84\x33\
\x34\x59\xab\xbb\xa8\x43\x33\x45\x9b\xbb\xa9\x54\x33\x45\x9b\xbb\xa8\x43\x33\x59\
\xab\xba\x84\x33\x45\xab\xbb\x95\x33\x35\x9b\xba\x94\x33\x46\xab\xba\x53\x33\x5a\
\xbb\xa5\x33\x47\xab\xb9\x43\x35\xab\xba\x53\x34\x9b\xba\x43\x35\xab\xb9\x43\x49\
\xbb\xa4\x33\x6a\xba\x53\x37\xab\x94\x34\x9b\xb8\x33\x6a\xba\xbb\xbb\xbb\xa9\x85\
\x44\x33\x33\x34\x56\x9a\xab\xbb\xba\xa9\x75\x43\x33\x33\x45\x89\xab\xbb\xba\xa9\
\x64\x43\x33\x44\x59\xaa\xbb\xba\xa9\x54\x33\x33\x45\x9a\xab\xbb\xa9\x64\x43\x33\
\x45\x9a\xbb\xba\xa8\x44\x33\x34\x79\xab\xbb\xa8\x54\x33\x45\x8a\xbb\xba\x95\x43\
\x34\x59\xab\xba\x96\x43\x34\x59\xab\xba\x95\x43\x34\x7a\xbb\xa9\x54\x33\x49\xab\
\xba\x74\x33\x48\xab\xba\x64\x33\x59\xab\xa9\x43\x34\x8a\xba\x94\x33\x49\xab\xa7\
\x43\x47\xab\xa9\x43\x45\xab\xa8\x43\x47\xab\xa6\x43\x49\xbb\x94\x34\x9b\xb9\x43\
\x49\xba\x84\x35\xab\xa5\x34\x7a\xba\xab\xbb\xba\xa9\x85\x44\x43\x33\x44\x57\x9a\
\xab\xbb\xba\xa9\x65\x44\x33\x34\x45\x89\xaa\xbb\xba\xa9\x54\x43\x33\x44\x59\xaa\
\xbb\xba\xa8\x54\x43\x34\x45\x8a\xab\xba\xa9\x65\x43\x34\x45\x9a\xab\xba\xa8\x54\
\x33\x44\x69\xab\xba\xa8\x54\x33\x45\x8a\xab\xaa\x95\x43\x34\x59\xaa\xba\x97\x44\
\x34\x59\xaa\xba\x95\x43\x44\x6a\xab\xa9\x54\x34\x47\xaa\xaa\x84\x44\x46\xaa\xba\
\x64\x44\x58\xab\xa9\x54\x44\x6a\xaa\x95\x44\x48\xab\xa9\x44\x45\xaa\xa9\x54\x45\
\x9a\xa9\x54\x45\xaa\xa8\x44\x48\xaa\x95\x44\x8a\xa9\x54\x48\xaa\x94\x44\x9a\xa7\
\x44\x5a\xa9\xaa\xaa\xaa\xa9\x85\x54\x44\x44\x44\x56\x99\xaa\xaa\xaa\xa9\x75\x44\
\x44\x44\x45\x79\xaa\xaa\xaa\xa9\x65\x44\x44\x44\x58\x9a\xaa\xaa\xa9\x65\x44\x44\
\x45\x69\xaa\xaa\xa9\x85\x44\x44\x45\x89\xaa\xaa\xa8\x54\x44\x44\x59\xaa\xaa\xa9\
\x54\x44\x44\x69\xaa\xaa\x96\x44\x44\x56\x9a\xaa\xa8\x54\x44\x46\x9a\xaa\xa7\x44\
\x44\x59\xaa\xaa\x85\x44\x45\x9a\xaa\x95\x44\x45\x9a\xaa\x95\x44\x46\x9a\xaa\x64\
\x44\x59\xaa\xa6\x44\x46\x9a\xa9\x54\x45\x8a\xaa\x64\x44\x8a\xaa\x64\x45\x9a\xa9\
\x54\x46\xaa\xa6\x44\x59\xaa\x84\x45\x9a\xa6\x44\x6a\xa9\x54\x49\xaa\xaa\xaa\xaa\
\xa9\x96\x55\x44\x44\x44\x56\x89\x9a\xaa\xaa\xa9\x86\x54\x44\x44\x45\x68\x9a\xaa\
\xaa\xa9\x85\x54\x44\x44\x56\x99\xaa\xaa\xa9\x85\x54\x44\x45\x69\x9a\xaa\xa9\x96\
\x54\x44\x45\x69\xaa\xaa\xa9\x65\x44\x44\x57\x9a\xaa\xa9\x75\x44\x44\x58\x9a\xaa\
\x98\x54\x44\x45\x9a\xaa\xa9\x65\x44\x45\x9a\xaa\xa8\x54\x44\x57\x9a\xaa\x95\x44\
\x45\x89\xaa\x97\x54\x45\x89\xaa\x96\x54\x45\x9a\xaa\x85\x44\x57\x9a\xa9\x54\x45\
\x8a\xa9\x85\x44\x69\xaa\x95\x44\x59\xaa\x95\x44\x69\xa9\x75\x45\x9a\xa8\x54\x58\
\xaa\x95\x44\x8a\xa9\x54\x59\xa9\x64\x46\xaa\x9a\xaa\xaa\xa9\x98\x65\x54\x44\x44\
\x55\x68\x99\xaa\xaa\xa9\x97\x55\x44\x44\x45\x58\x99\xaa\xaa\x99\x86\x55\x44\x44\
\x56\x89\x9a\xaa\xa9\x86\x55\x44\x45\x57\x99\xaa\xa9\x97\x55\x44\x45\x58\x99\xaa\
\xa9\x86\x54\x44\x56\x89\xaa\xa9\x86\x54\x44\x57\x99\xaa\x99\x65\x44\x55\x79\x9a\
\xa9\x85\x54\x45\x79\x9a\x99\x65\x44\x56\x99\xaa\x97\x54\x45\x69\x9a\x98\x55\x45\
\x69\x9a\x98\x55\x45\x69\xaa\x96\x54\x56\x99\xa9\x65\x45\x69\x99\x95\x54\x58\x9a\
\x96\x54\x58\x9a\x96\x54\x59\x99\x95\x55\x69\xa9\x65\x56\x9a\x97\x55\x69\x99\x65\
\x56\x99\x95\x55\x89\x99\x99\x99\x99\x98\x66\x55\x55\x55\x55\x68\x99\x99\x99\x99\
\x98\x65\x55\x55\x55\x56\x89\x99\x99\x99\x98\x65\x55\x55\x55\x68\x99\x99\x99\x98\
\x65\x55\x55\x56\x89\x99\x99\x98\x65\x55\x55\x56\x89\x99\x99\x86\x55\x55\x56\x79\
\x99\x99\x96\x55\x55\x56\x89\x99\x99\x86\x55\x55\x68\x99\x99\x86\x55\x55\x68\x99\
\x99\x86\x55\x55\x79\x99\x98\x65\x55\x68\x99\x99\x75\x55\x57\x99\x99\x65\x55\x68\
\x99\x98\x65\x55\x79\x99\x86\x55\x58\x99\x97\x55\x56\x99\x98\x65\x56\x89\x98\x55\
\x57\x99\x97\x55\x68\x99\x85\x55\x89\x98\x55\x58\x99\x85\x56\x89\x96\x55\x69\x98\
\x99\x99\x99\x98\x86\x65\x55\x55\x55\x67\x88\x99\x99\x99\x98\x76\x55\x55\x55\x66\
\x78\x99\x99\x99\x88\x66\x55\x55\x56\x68\x89\x99\x99\x88\x66\x55\x55\x56\x78\x99\
\x99\x98\x76\x55\x55\x56\x88\x99\x99\x88\x66\x55\x56\x68\x89\x99\x88\x66\x55\x56\
\x78\x99\x99\x86\x65\x55\x67\x89\x99\x88\x65\x55\x67\x89\x99\x87\x65\x56\x68\x99\
\x98\x76\x55\x66\x89\x98\x86\x55\x66\x89\x98\x86\x55\x67\x89\x98\x66\x56\x68\x99\
\x86\x65\x66\x89\x98\x66\x56\x88\x98\x66\x56\x88\x98\x66\x66\x88\x88\x66\x66\x88\
\x86\x66\x68\x88\x76\x66\x88\x86\x66\x78\x88\x66\x68\x88\x88\x88\x88\x88\x87\x66\
\x66\x66\x66\x66\x88\x88\x88\x88\x88\x86\x66\x66\x66\x66\x78\x88\x88\x88\x88\x76\
\x66\x66\x66\x67\x88\x88\x88\x88\x76\x66\x66\x66\x78\x88\x88\x88\x86\x66\x66\x66\
\x78\x88\x88\x88\x76\x66\x66\x67\x88\x88\x88\x76\x66\x66\x67\x88\x88\x87\x66\x66\
\x67\x78\x88\x87\x76\x66\x67\x78\x88\x87\x66\x66\x67\x88\x88\x77\x66\x67\x78\x88\
\x77\x66\x67\x78\x88\x77\x76\x67\x77\x87\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\
\x77\x77\
'
#------------------------------------------------------------
# Main Loop
#------------------------------------------------------------
while True:
    if mode == "title":
        # title
        screen.fill(12, screenRect)
        pok.draw_text(0, 4, "Pokitto", 3)
        pok.draw_text(1, 3, "Pokitto", 11)
        pok.draw_text(2, 2, "Pokitto", 7)
        screen.blit(logoSurface, 0, 14)
        pok.draw_text(66, 58, "Ver.0.1", 7)
        pok.draw_text(12, 70, "HI:"+str(hi), 7)
        pok.draw_text(12, 80, "Push A to start!", 7)
        eventtype = upg.event.poll()
        if eventtype != upg.NOEVENT:
            if eventtype.type == upg.KEYDOWN:
                if eventtype.key == upg.BUT_A:
                    mode = "init"
    if mode == "init":
        tm = 0
        tm_dead = 0
        x = 59 * 1000
        y = 44 * 1000
        vx = 0
        vy = 0
        sc = 0
        alive = True
        powcount = 0
        
        list_shots = []
        list_bullets = []
        list_explosions = []
        list_enemies = []
        list_clouds = []
        list_players = []
        list_pows = []
        
        player = GameObject(playerSurfaces, x, y, 8, 8, 0, 0)
        player.surfno = 0
        list_players.append(player)
        mode = "game"
        tm = 0
    if mode == "game":
        # game
        # pok.draw_text(0, 8, "free:" + str(gc.mem_free()), 7)
        # draw bitmaps
        screen.fill(12, screenRect) 
        for pow in list_pows:
            if tm % 2 == 0:
                screen.blit(pow.surfaces[0], pow.x//1000, pow.y//1000)
        for shot in list_shots:
            screen.blit(shot.surfaces[0], shot.x//1000, shot.y//1000)
        for player in list_players:   
            screen.blit(player.surfaces[tm % 2], player.x//1000, player.y//1000)
        for explosion in list_explosions:
            no = tm - explosion.tm -1
            if no < 5:
                screen.blit(explosion.surfaces[no], explosion.x//1000, explosion.y//1000)
            else:
                explosion.status = 0
        for enemy in list_enemies:
            screen.blit(enemy.surfaces[enemy.surfno], enemy.x//1000, enemy.y//1000)
        for bullet in list_bullets:
            screen.blit(bullet.surfaces[0], bullet.x//1000, bullet.y//1000)
        for cloud in list_clouds:
            screen.blit(cloud.surfaces[0], cloud.x//1000, cloud.y//1000)        
        
        #controller
        if alive:            
            eventtype = upg.event.poll()
            if eventtype != upg.NOEVENT:
                if eventtype.type == upg.KEYDOWN:
                    if eventtype.key == upg.K_RIGHT:
                        vx = 2000
                    if eventtype.key == upg.K_LEFT:
                        vx = -2000
                    if eventtype.key == upg.K_UP:
                        vy = -2000
                    if eventtype.key == upg.K_DOWN:
                        vy = 2000
                    if eventtype.key == upg.BUT_A:
                        if len(list_shots) < len(list_players)*2:
                            for player in list_players:
                                shot = GameObject(shotSurfaces, player.x, player.y-8000, 8, 8, 0, -2000)
                                list_shots.append(shot)
                if eventtype.type == upg.KEYUP:
                    if eventtype.key == upg.K_RIGHT:
                        vx = 0
                    if eventtype.key == upg.K_LEFT:
                        vx = 0
                    if eventtype.key == upg.K_UP:
                        vy = 0
                    if eventtype.key == upg.K_DOWN:
                        vy = 0
                        
            minx = 102000
            maxx =      0
            miny =  80000
            maxy =  0
            for player in list_players:
                if player.x < minx:
                    minx = player.x
                if player.x > maxx:
                    maxx = player.x
                if player.y < miny:
                    miny = player.y
                if player.y > maxy:
                    maxy = player.y
            
            if minx + vx <   0:
                vx =        - minx
            if maxx + vx > 102000:
                vx = 102000 - maxx
            if miny + vy <   16000:
                vy =  16000 - miny
            if maxy + vy >  72000:
                vy =  72000 - maxy
            
            # list_players
            for player in list_players:
                player.x += vx
                player.y += vy
                if player.x//1000 < -16 or player.x//1000 >= 110+16 or player.y//1000 < -16 or player.y//1000 >= 88+16:
                    player.status = 0
            res = []
            for player in list_players:
                if player.status != 0:
                    res.append(player)
            list_players = res;
            
            if alive and len(list_players) == 0:
                alive = False
            tm_dead = tm
            
            sound = False
            # collision 1
            # shots and enemies
            for shot in list_shots:
                for enemy in list_enemies:
                    if abs(enemy.x//1000 - shot.x//1000)*2 <= (enemy.w + shot.w) and abs(enemy.y//1000 - shot.y//1000)*2 <= (enemy.h + shot.h):
                        sound = True
                        shot.status = 0
                        enemy.status = 0
                        sc += enemy.pts
                        explosion = GameObject(explosionSurfaces, enemy.x, enemy.y, 8, 8, 0, 0)
                        explosion.tm = tm
                        list_explosions.append(explosion)
                        if enemy.type == 2:
                            powcount += 1
                            if powcount >= 5:
                                powcount = 0
                                pow = GameObject(playerSurfaces, enemy.x, enemy.y, 8, 8, 0, 500)
                                list_pows.append(pow)

            if sound:
                g_sound.play_sfx(sound1, len(sound1), True)
    
            sound = False
            # collision 2
            # player and enemies
            for player in list_players:
                for enemy in list_enemies:
                    if abs(enemy.x//1000 - player.x//1000)*2 <= (enemy.w + player.w) and abs(enemy.y//1000 - player.y//1000)*2 <= (enemy.h + player.h):
                        sound = True
                        enemy.status = 0
                        player.status = 0
                        sc += enemy.pts
                        explosion = GameObject(explosionSurfaces, enemy.x, enemy.y, 8, 8, 0, 0)
                        explosion.tm = tm
                        list_explosions.append(explosion)
                        explosion = GameObject(explosionSurfaces, player.x, player.y, 8, 8, 0, 0)
                        explosion.tm = tm
                        list_explosions.append(explosion)
            # collision 3
            # player and bullet
            for player in list_players:
                for bullet in list_bullets:
                    if abs(bullet.x//1000 - player.x//1000)*2 <= (bullet.w + player.w) and abs(bullet.y//1000 - player.y//1000)*2 <= (bullet.h + player.h):
                        sound = True
                        bullet.status = 0
                        player.status = 0
                        explosion = GameObject(explosionSurfaces, bullet.x, bullet.y, 8, 8, 0, 0)
                        explosion.tm = tm
                        list_explosions.append(explosion)
                        explosion = GameObject(explosionSurfaces, player.x, player.y, 8, 8, 0, 0)
                        explosion.tm = tm
                        list_explosions.append(explosion)
            if sound:
                g_sound.play_sfx(sound2, len(sound1), True)
            # collision 4
            # player and pow
            sound = False
            res = []
            for player in list_players:
                res.append(player)
                for pow in list_pows:
                    if abs(pow.x//1000 - player.x//1000)*2 <= (pow.w + player.w) and abs(pow.y//1000 - player.y//1000)*2 <= (pow.h + player.h):
                        sound = True
                        pow.status = 0
                        if len(list_players) < 3:
                            pow = GameObject(playerSurfaces, pow.x, pow.y, 8, 8, 0, 0)
                            res.append(pow)
                        else:
                            sc = +1000
            list_players = res
            if sound:
                g_sound.play_sfx(sound3, len(sound1), True)

        # list_shots
        for shot in list_shots:
            shot.x += shot.vx
            shot.y += shot.vy
            if shot.x//1000 < -16 or shot.x//1000 >= 110+16 or shot.y//1000 < -16 or shot.y//1000 >= 88+16:
                shot.status = 0
        res = []
        for shot in list_shots:
            if shot.status != 0:
                res.append(shot)
        list_shots = res;

        # list_bullets
        for bullet in list_bullets:
            bullet.x += bullet.vx
            bullet.y += bullet.vy
            if bullet.x//1000 < -16 or bullet.x//1000 >= 110+16 or bullet.y//1000 < -16 or bullet.y//1000 >= 88+16:
                bullet.status = 0
        res = []
        for bullet in list_bullets:
            if bullet.status != 0:
                res.append(bullet)
        list_bullets = res

        # list_enemies
        for enemy in list_enemies:
            enemy.x += enemy.vx
            enemy.y += enemy.vy
            
            # enemy 1
            if enemy.type == 1:
                if enemy.x//1000 < -16 or enemy.x//1000 >= 110+16 or enemy.y//1000 < -16 or enemy.y//1000 >= 88+16:
                    enemy.status = 0
                if enemy.surfno == 3:
                    enemy.dir = (32 - enemy.dir + randint(-1, 1, 2) + 32)%32
                    if enemy.dir == 0:
                        print(str(bakdir) + "," + str(enemy.dir) + "|" + "|" + str(bakvx) + "," + str(bakvy)+str(enemy.vx) + "," + str(enemy.vy)+ "\n")
                        
                    enemy.vx = 3*cos[enemy.dir]
                    enemy.vy = 3*sin[enemy.dir]
                if enemy.surfno >= 1 and enemy.surfno <= 5:
                    enemy.surfno += 1
                if enemy.surfno == 0 and enemy.y//1000 >= y//1000 - 16 and random.getrandbits(5) <= 4:
                    enemy.surfno = 1
                    
            # enemy 2
            elif enemy.type == 2:
                if enemy.x//1000 < -16 or enemy.x//1000 >= 110+16 or enemy.y//1000 < -16 or enemy.y//1000 >= 88+16:
                    if not enemy.status == 1:
                        enemy.status = 0
                elif enemy.status == 1:
                    enemy.status = 2
                    enemy.tm = tm
                elif enemy.status == 2 and enemy.x >= 24000:
                    enemy.status = 3
                    enemy.tm = tm
                elif enemy.status == 3 or enemy.status == 5:
                    if enemy.dir == 31 and enemy.y <= 8000:
                        enemy.status += 1
                        enemy.y = 8000
                        enemy.dir = 0
                        enemy.surfno = 0
                        enemy.vx = 2000
                        enemy.vy = 0
                    else:
                        enemy.dir = ((tm - enemy.tm)//2)%32
                        enemy.surfno = ((enemy.dir+31)//4)%8
                        enemy.vx = 2*cos[enemy.dir]
                        enemy.vy = 2*sin[enemy.dir]
                elif enemy.status == 4 and enemy.x >= 78000:
                    enemy.status = 5
                    enemy.tm = tm
            p = 4 + tm % 50
            if p > 24:
                p = 24
            if random.getrandbits(12) < p and len(list_bullets) < 20 and dist2(x//1000, y//1000, enemy.x//1000, enemy.y//1000) > 12*12:
                d = (atan2(y- enemy.y, x - enemy.x) + randint(-1, 1, 4))%32
                bullet = GameObject(bulletSurfaces, enemy.x, enemy.y, 4, 4, 3*cos[d], 3*sin[d])
                list_bullets.append(bullet)
        res = []
        for enemy in list_enemies:
            if enemy.status != 0:
                res.append(enemy)
        list_enemies = res;
        # list_explosions
        for explosion in list_explosions:
            explosion.x += explosion.vx
            explosion.y += explosion.vy
            if explosion.x//1000 < -16 or explosion.x//1000 >= 110+16 or explosion.y//1000 < -16 or explosion.y//1000 >= 88+16:
                explosion.status = 0
        res = []
        for explosion in list_explosions:
            if explosion.status != 0:
                res.append(explosion)
        list_explosions = res;
        
        # list_clouds
        for cloud in list_clouds:
            cloud.x += cloud.vx
            cloud.y += cloud.vy
            if cloud.x//1000 < -40 or cloud.x//1000 >= 110+32 or cloud.y//1000 < -32 or cloud.y//1000 >= 88+32:
                cloud.status = 0
        res = []
        for cloud in list_clouds:
            if cloud.status != 0:
                res.append(cloud)
        list_clouds = res;
        
        # list_pows
        for pow in list_pows:
            pow.x += pow.vx
            pow.y += pow.vy
            if pow.x//1000 < -40 or pow.x//1000 >= 110+32 or pow.y//1000 < -32 or pow.y//1000 >= 88+32:
                pow.status = 0
        res = []
        for pow in list_pows:
            if pow.status != 0:
                res.append(pow)
        list_pows = res;
        
        # generate enemies
        # enemy 1
        p = 12 - tm % 200
        if p < 6:
            p = 6
        if tm % p == 0:
            enemy = GameObject(enemy01Surfaces, randint(-8, 110+8, 7)*1000, randint(-16, -8, 3)*1000, 8, 8, 0, 0)
            enemy.type = 1
            enemy.pts = 10
            enemy.dir = atan2((y - enemy.y)//1000 + randint(-24, 24, 6), (x - enemy.x)//1000 + randint(-24, 24, 6))
            enemy.vx = cos[enemy.dir] * 2
            enemy.vy = sin[enemy.dir] * 2
            list_enemies.append(enemy)
        # enemy 2
        if (tm + 150) % 400 == 0:
            powcount = 0
            for i in range(0, 5):
                enemy = GameObject(enemy02Surfaces, -12*(i+1)*1000, 8*1000, 8, 8, 2000, 0)
                enemy.type = 2
                enemy.pts = 20
                enemy.dir = 0
                enemy.tm = tm
                list_enemies.append(enemy)
        # generate clouds
        if random.getrandbits(3) <= 1:
            cloud = GameObject(cloudSurfaces, randint(-7, 63, 7)*2000, (random.getrandbits(3)-12)*2000, 8, 8, 0, 6000)
            list_clouds.append(cloud)
        
        if alive:
            pok.draw_text(0, 0, "SC:  " + str(sc), 7);
        else:
            if tm - tm_dead < 200:
                pok.draw_text(32, 26, "Game Over", 8);
                pok.draw_text(32, 37, "HI:  " + str(hi), 10);
                pok.draw_text(32, 46, "SC:  " + str(sc), 10);
                if sc > hi:
                    pok.draw_text(32, 54, "High Score!", 8);
            else:
                if sc > hi:
                    hi = sc
                mode = "title"
                
    upg.display.flip()
    tm += 1
